Imports System
Imports System.IO

Public Class DirectorySize
  
  Inherits System.Web.UI.Page
  
  Public Function Size(ByVal virtualPath As String) As String
    'do some basic checking on the folder path passed in the URL
    If virtualPath = "" Then
      virtualPath = "/"
    ElseIf virtualPath.EndsWith("/") Then
      virtualPath = virtualPath.Substring(0, virtualPath.Length - 1)
    End If
    'change folder location from virtual to physical path
    Dim physicalPath As String = Server.MapPath(virtualPath)
    'call function GetFolderSize 
    'to get the size of the folder as Double
    Dim folderSize As Double = GetFolderSize(physicalPath)
    'call function FormatSize 
    'to format the size as String and for a better display
    Dim strSize As String = FormatSize(folderSize)
    'output for this function
    Return strSize
  End Function

  Private Function GetFolderSize(ByVal physicalPath As String) As Double
    Dim dblDirSize As Double = 0
    Dim objDirInfo As DirectoryInfo = New DirectoryInfo(physicalPath)
    Dim arrChildFiles As Array = objDirInfo.GetFiles()
    Dim arrSubFolders As Array = objDirInfo.GetDirectories()
    Dim objChildFile As FileInfo
    Dim objChildFolder As DirectoryInfo
    'first loop through the files and add the size of each file
    For Each objChildFile in arrChildFiles
      dblDirSize += objChildFile.Length
    Next
    'then for each subfolder found call this function again
    For Each objChildFolder in arrSubFolders
      dblDirSize += GetFolderSize(objChildFolder.FullName)
    Next
    Return dblDirSize
  End Function
  
  Private Function FormatSize(ByVal dblFileSize as Double) As String
    If dblFileSize < 1024 Then
      Return String.Format("{0:N0} B", dblFileSize)
    ElseIf dblFileSize < 1024 * 1024 Then
      Return String.Format("{0:N2} KB", dblFileSize/1024)
    ElseIf dblFileSize < 1024 * 1024 * 1024 Then
      Return String.Format("{0:N2} MB", dblFileSize/(1024*1024))
    ElseIf dblFileSize >= 1024 * 1024 * 1024 Then
      Return "Size in the GB!"
    End If
  End Function
  
End Class